//@line 37 "/builddir/build/BUILD/spicebird-0.4/mozilla/collab/components/csSplashWindow.js"

/*
 * Stole the idea from Splash! firefox addon.
 */

const SPLASH_CMDLINE_CONTRACTID    = "@synovel.com/collab/splash;1";
const SPLASH_CMDLINE_CLSID         = Components.ID('{028a39ce-71a4-432d-b4db-63fd03ab86aa}');
const CATMAN_CONTRACTID            = "@mozilla.org/categorymanager;1";
const nsISupports                  = Components.interfaces.nsISupports;

const nsICategoryManager           = Components.interfaces.nsICategoryManager;
const nsIComponentRegistrar        = Components.interfaces.nsIComponentRegistrar;
const nsICommandLine               = Components.interfaces.nsICommandLine;
const nsICommandLineHandler        = Components.interfaces.nsICommandLineHandler;
const nsIFactory                   = Components.interfaces.nsIFactory;
const nsIModule                    = Components.interfaces.nsIModule;
const nsISupportsString            = Components.interfaces.nsISupportsString;
const nsIWindowWatcher             = Components.interfaces.nsIWindowWatcher;

const SplashCmdLineHandler = {
  firstTime: true,
  
  /* nsISupports */
  QueryInterface : function handler_QI(iid) {
    if (iid.equals(nsISupports) ||
        iid.equals(nsICommandLineHandler) ||
        iid.equals(nsIFactory))
      return this;

    throw Components.results.NS_ERROR_NO_INTERFACE;
  },

  /* nsICommandLineHandler */

  handle : function handler_handle(cmdLine) {
    if (this.firstTime && !cmdLine.handleFlag("nosplash", false)) {
      var wwatch = Components.classes["@mozilla.org/embedcomp/window-watcher;1"]
                             .getService(nsIWindowWatcher);
      wwatch.openWindow(null, "chrome://collab/content/splash.xul", "_blank",
                        "chrome,centerscreen,alwaysRaised=yes,titlebar=no,modal=yes,popup=yes", cmdLine);
      this.firstTime = false;
    }
  },

  helpInfo : "  -nosplash             Start without a splash screen.\n",

  /* nsIFactory */

  createInstance : function (outer, iid) {
    if (outer != null)
      throw Components.results.NS_ERROR_NO_AGGREGATION;

    return this.QueryInterface(iid);
  },

  lockFactory : function (lock) {
  }
};

var SplashCmdLineModule = {
  registerSelf: function(compMgr, fileSpec, location, type) {
    compMgr = compMgr.QueryInterface(nsIComponentRegistrar);

    compMgr.registerFactoryLocation(SPLASH_CMDLINE_CLSID,
                                    "Splash CommandLine Service",
                                    SPLASH_CMDLINE_CONTRACTID,
                                    fileSpec,
                                    location,
                                    type);

    var catman = Components.classes[CATMAN_CONTRACTID].getService(nsICategoryManager);
    catman.addCategoryEntry("command-line-argument-handlers",
                            "splash command line handler",
                            SPLASH_CMDLINE_CONTRACTID, true, true);
    catman.addCategoryEntry("command-line-handler",
                            "m-splash",
                            SPLASH_CMDLINE_CONTRACTID, true, true);
  },

  unregisterSelf: function(compMgr, fileSpec, location) {
    compMgr = compMgr.QueryInterface(nsIComponentRegistrar);

    compMgr.unregisterFactoryLocation(SPLASH_CMDLINE_CLSID, fileSpec);
    catman = Components.classes[CATMAN_CONTRACTID].getService(nsICategoryManager);
    catman.deleteCategoryEntry("command-line-argument-handlers",
                               "splash command line handler", true);
    catman.deleteCategoryEntry("command-line-handler",
                               "m-splash", true);
  },

  getClassObject: function(compMgr, cid, iid) {
    if (cid.equals(SPLASH_CMDLINE_CLSID)) {
      return SplashCmdLineHandler.QueryInterface(iid);
    }

    if (!iid.equals(Components.interfaces.nsIFactory)) {
      throw Components.results.NS_ERROR_NOT_IMPLEMENTED;
    }

    throw Components.results.NS_ERROR_NO_INTERFACE;
  },

  canUnload: function(compMgr) {
    return true;
  }
};


function NSGetModule(compMgr, fileSpec) {
  return SplashCmdLineModule;
}

